<html>
  <head>
    <title>
    The Structure Of The LDAS Disk Cache File
    </title>
  </head>
  <body bgcolor=#cccccc>
     <center>
     <font color=green>
        <h2>
        The Structure Of The LDAS Disk Cache File
        </h2>
     </font>
     </center>
    
     The LDAS diskcacheAPI records the state of directories
     containing frame files in a file:<p>
     <center>
     <b><i>/ldas_outgoing/.frame.cache</i></b>
     </center>
     <p>
     This file contains the result of running the Tcl command
     <b>array get ::disk::cache</b>, which produces a Tcl list
     consisting of <b><i>key/value</i></b> pairs of associative
     array keys and their stored values.<br>
     The structure represented in the file "begins" (the entries
     are in no particular order, being internally represented as
     a hash) with the directories defined in the
     <b><i>LDASapi.rsc</i></b> file as the <b><i>::MOUNT_PT</i></b>
     values. The structure shows descendants of the mount point
     directories and all frame files found therein.<br>
     <p>
     Each directory has an entry for <b><i>integrity</i></b>,
     which can have the value <b><i>-1, 0, or 1</i></b>.<br>
     <ul>
     <li>A value of <b>-1</b> indicates that no frame files were
     found in the directory.
     <li>A value of <b>0</b> means that the directory has changed and
     needs to be updated (very rare to see in the file on disk!).
     <li>A value of <b>1</b> means the directory has got frames in it
     and their names can be calculated based on the directory
     information in the array.
     </ul>
     
     <h3>The File (showing the E7 data as on ldas-dev):</h3>

<pre>
/imports/E7 <font color=red>a 'toplevel', an element of ::MOUNT_PT</font>
/imports/E7,integrity -1 <font color=red>no files here</font>
/imports/E7,ifos {} <font color=red>thus no ifos represented</font>
/imports/E7,mtime 1010026050
  
  /imports/E7/LHO 
  <font color=red>a subdir which contains no frames</font>
  /imports/E7/LHO,integrity -1
  /imports/E7/LHO,ifos {}
  /imports/E7/LHO,mtime 1010194183
  /imports/E7/LLO 
  <font color=red>ditto</font>
  /imports/E7/LLO,integrity -1
  /imports/E7/LLO,ifos {}
  /imports/E7/LLO,mtime 1010194188
    
    /imports/E7/LHO/frames
    <font color=red>this is the directory name</font>
    /imports/E7/LHO/frames,integrity 1 
    <font color=red>there are frames here</font>
    /imports/E7/LHO/frames,ifos H 
    <font color=red>for the ifo '<b>H</b>'</font>
    /imports/E7/LHO/frames,mtime 1010194163
    /imports/E7/LHO/frames,H {} 
    <font color=brown>key without value, used for searching</font> 
    /imports/E7/LHO/frames,H,types R 
    <font color=red>only type '<b>R</b>' frames are found here</font>
      
      /imports/E7/LHO/frames,H,R {} 
      <font color=brown>key without value, used for searching</font>
      /imports/E7/LHO/frames,H,R,dts 16 
      <font color=red>only 16 second frames here</font>
      /imports/E7/LHO/frames,H,R,exts gwf 
      <font color=red>all frames here have extension <b>.gwf</b></font>
      /imports/E7/LHO/frames,H,R,Ns 1 
      <font color=red>all frame files here contain ONE frame object</font>
      /imports/E7/LHO/frames,H,R,1,16,n 450 
      <font color=red>there are 450 frames <b>of this type</b> in this directory</font>
      /imports/E7/LHO/frames,H,R,1,16,name official 
      <font color=red>the frames of this type are named according to the <b>official</b> frame naming convention</font>
      /imports/E7/LHO/frames,H,R,1,16 {693960000 693967200} 
      <font color=red>the frames here cover the contigous time range 693960000-693967200</font>
    
    /imports/E7/LLO/frames
    /imports/E7/LLO/frames,integrity 1
    /imports/E7/LLO/frames,ifos L
    /imports/E7/LLO/frames,mtime 1010194119
    /imports/E7/LLO/frames,L {} 
    <font color=brown>key without value, used for searching</font>
    /imports/E7/LLO/frames,L,types R
      
      /imports/E7/LLO/frames,L,R {} 
      <font color=brown>key without value, used for searching</font>
      /imports/E7/LLO/frames,L,R,dts 16
      /imports/E7/LLO/frames,L,R,exts gwf
      /imports/E7/LLO/frames,L,R,Ns 1
      /imports/E7/LLO/frames,L,R,1,16,n 450
      /imports/E7/LLO/frames,L,R,1,16,name official
      /imports/E7/LLO/frames,L,R,1,16 {693960000 693967200}
        
    </pre>
    <b>
    Note that a directory containing non-contiguous time data will
    be represented by the time range entry containing as many pairs
    of begin and end times listed as required to account for all the
    contained data.
    <p>
    The IFO, type, extension, dt, and N entries MAY consist of lists
    if the directory contains mixed data.
    <p>
    The value of N is currently always 1.  Only the frame API can
    determine the number of files in a frame file, and it has not
    yet been decided whether it should participate in the construction
    of the cache information.  There may be a means of determining
    this value without the use of the frame API; stay tuned.
    </b>
  </body>
</html>  
